import java.awt.*;
public class DrawningFastBulldozer extends DrawningBulldozer {
    public DrawningFastBulldozer(int speed, double weight, Color bodyColor, boolean covsh, boolean rearbucket, Color covshColor, Color rearbucketColor, int width, int height, int wheelNumber)
    {
        super(speed, weight, bodyColor, width, height, 160, 90, wheelNumber);
        if (getEntityBulldozer() != null)
        {
            setEntityBulldozer(new EntityFastBulldozer(speed, weight, bodyColor, covsh, rearbucket, covshColor, rearbucketColor));
        }
    }
    @Override
    public void DrawTransport(Graphics2D g2D) {
        if (!(getEntityBulldozer() instanceof EntityFastBulldozer fastBulldozer)) {
            return;
        }
        super.DrawTransport(g2D);
        if (fastBulldozer.getCovsh())
        {
            g2D.setPaint(fastBulldozer.getCovshColor());
            int[] xPoints = {_startPosX + 25, _startPosX + 25, _startPosX};
            int[] yPoints = {_startPosY + 30, _startPosY + 80, _startPosY + 80};
            Polygon triangle = new Polygon(xPoints, yPoints, 3);
            g2D.drawPolygon(triangle);
        }
        if (fastBulldozer.getRearbucket() && fastBulldozer.getCovsh())
        {
            g2D.setPaint(fastBulldozer.getRearbucketColor());
            int[] xPoints2 = {_startPosX + 130, _startPosX + 160, _startPosX + 160};
            int[] yPoints2 = {_startPosY + 50, _startPosY + 50, _startPosY + 80};
            Polygon triangle2 = new Polygon(xPoints2, yPoints2, 3);
            g2D.drawPolygon(triangle2);
        }
    }
}
